Subject: bug#49990: [core-updates-frozen] Ant-bootstrap broken by classpath-bootstrap

From: Efraim Flashner <[email-masked]>
Date: Mon, 30 Aug 2021 14:51:41 +0300

On Tue, Aug 10, 2021 at 11:38:01PM +0200, Julien Lepiller wrote:
> Hi Guix!
> 
> I've finally taken the time to investigate the build failure of
> ant-bootstrap. It is failing after reporting a file exists:
> 

I tried working around it a different way, and tried removing some lines
from build.xml but didn't make it to a built package.

Interestingly, ant-bootstrap as it currently exists in
core-updates-frozen, builds just fine on armhf, aarch64 and powerpc.

> ```
> /tmp/guix-build-ant-bootstrap-1.8.4.drv-0/apache-ant-1.8.4/build.xml:558:
> Unable to create directory as a file already exists with that name:
> /tmp/guix-build-ant-bootstrap-1.8.4.drv-0/apache-ant-1.8.4/build
> ```
> 
> So, I set an environment variable to pass a different build directory
> to ant (-Dbuild.dir=bootstrapped-build), but it fails in the same way:
> 
> ```
> /tmp/guix-build-ant-bootstrap-1.8.4.drv-0/apache-ant-1.8.4/build.xml:558:
> Unable to create directory as a file already exists with that name:
> /tmp/guix-build-ant-bootstrap-1.8.4.drv-0/apache-ant-1.8.4/bootstrapped-build
> ```
> 
> However, using -K, I could check the directory does not exist. After
> investigating a bit, I found that File.isFile() is not working as
> expected. With the following file (Test.java):
> 
> ```
> import java.io.File;
> public class Test {
>   public static void main(String[] args) {
>     File f = new File("non-existent");
>     if(f.isFile())
>       System.out.println("yes");
>     else
>       System.out.println("no");
>   }
> }
> ```
> 
> compiled in a guix environment for ant-bootstrap (I had to temporarily
> export it):
> 
> ```
> $ ./pre-inst-env guix environment ant-bootstrap
> [env]$ CLASSPATH=$GUIX_ENVIRONMENT/lib/rt.jar jikes Test.java
> [env]$ java Test
> no
> [env]$ jamvm Test
> yes
> ```
> 
> (java comes from outside the environment). jamvm from master is
> working, and I don't see any difference in it, classpath or jikes
> recipes.
> 
> After investigation, it turns out that java.io.File is actually
> implemented in classpath, not jamvm, and there is a comment that refers
> to another similar issue:
> 
> https://issues.guix.gnu.org/issue/36685
> 
> I tried the obvious, that is to introduce a new memory leak, but that
> did not work. So, to better understand what was going on, I instead
> added some printing:
> 
> ```
> @@ -256,7 +256,9 @@ only faster.")
>             (lambda _
>               (substitute* "native/jni/java-io/java_io_VMFile.c"
>                 (("result = cpio_isFileExists.*" m)
> -                (string-append m "\n//")))
> +                (string-append m "\n//"))
> +               (("result = cpio_checkType.*" m)
> +                (string-append m "\nfprintf(stderr, \"type? %s : %d --
> %d -- %d;\\n\", filename, result, entryType, ((result == CPNATIVE_OK &&
> entryType == CPFILE_FILE) ? 1 : 0));\n"))) #t)) (add-after 'install
> 'install-data (lambda _ (invoke "make" "install-data"))))))
> ```
> 
> and surprisingly, this prints the expected values, and it is enough to
> get the correct answer from the java side too. With the above diff, I'm
> able to build ant-bootstrap and all the dependencies of icedtea@1, with
> a lot of useless debug lines... Unfortunately icedtea itself ends in a
> failure after building quite a lot.

I was able to use your diff to build ant-bootstrap for x86_64. aarch64,
armhf and powerpc still build and i686 still fails.

I'm not sure why icedtea@1 didn't build for you, I was able to build it
on x86_64. The other architectures are building more slowly.

Looks to me like you should add it, with a comment like:
With the power of ... debug spam? we magically enable building on x86_64.

-- 
Efraim Flashner   <[email-masked]>   רנשלפ םירפא
GPG key = A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
Confidentiality cannot be guaranteed on emails sent or received unencrypted